# Copyright (c) 2013, Mark Peek <mark@peek.org>
# All rights reserved.
#
# See LICENSE file for full license.

from . import AWSObject, Ref
from .validators import integer


class CacheCluster(AWSObject):
    type = "AWS::ElastiCache::CacheCluster"

    props = {
        'AutoMinorVersionUpgrade': (bool, False),
        'CacheNodeType': (str, True),
        'CacheParameterGroupName': (str, False),
        'CacheSecurityGroupNames': ([str, Ref], True),
        'CacheSubnetGroupName': (str, False),
        'Engine': (str, True),
        'EngineVersion': (str, False),
        'NotificationTopicArn': (str, False),
        'NumCacheNodes': (integer, False),
        'Port': (int, False),
        'PreferredAvailabilityZone': (str, False),
        'PreferredMaintenanceWindow': (str, False),
        'SnapshotArns': ([str, Ref], False),
        'VpcSecurityGroupIds': ([str, Ref], False),
    }


class ParameterGroup(AWSObject):
    type = "AWS::ElastiCache::ParameterGroup"

    props = {
        'CacheParameterGroupFamily': (str, True),
        'Description': (str, True),
        'Properties': (dict, True),
    }


class SecurityGroup(AWSObject):
    type = "AWS::ElastiCache::SecurityGroup"

    props = {
        'Description': (str, True),
    }


class SecurityGroupIngress(AWSObject):
    type = "AWS::ElastiCache::SecurityGroupIngress"

    props = {
        'CacheSecurityGroupName': (str, True),
        'EC2SecurityGroupName': (str, True),
        'EC2SecurityGroupOwnerId': (str, False),
    }
