# Copyright (c) 2013, Mark Peek <mark@peek.org>
# All rights reserved.
#
# See LICENSE file for full license.

from . import AWSHelperFn, AWSObject, AWSProperty
from .validators import boolean


class DBInstance(AWSObject):
    type = "AWS::RDS::DBInstance"

    props = {
        'AllocatedStorage': (str, True),
        'AutoMinorVersionUpgrade': (bool, False),
        'AvailabilityZone': (str, False),
        'BackupRetentionPeriod': (str, False),
        'DBInstanceClass': (str, True),
        'DBName': (str, False),
        'DBParameterGroupName': (str, False),
        'DBSecurityGroups': (list, False),
        'DBSnapshotIdentifier': (str, False),
        'DBSubnetGroupName': (str, False),
        'Engine': (str, True),
        'EngineVersion': (str, False),
        'Iops': (int, False),
        'LicenseModel': (str, False),
        'MasterUsername': (str, True),
        'MasterUserPassword': (str, True),
        'MultiAZ': (boolean, False),
        'Port': (str, False),
        'PreferredBackupWindow': (str, False),
        'PreferredMaintenanceWindow': (str, False),
        'Tags': (list, False),
        'VPCSecurityGroups': ([str, AWSHelperFn], False),
    }


class DBParameterGroup(AWSObject):
    type = "AWS::RDS::DBParameterGroup"

    props = {
        'Description': (str, False),
        'Family': (str, False),
        'Parameters': (dict, False),
    }


class DBSubnetGroup(AWSObject):
    type = "AWS::RDS::DBSubnetGroup"

    props = {
        'DBSubnetGroupDescription': (str, True),
        'SubnetIds': (list, True),
    }


class RDSSecurityGroup(AWSProperty):
    props = {
        'CIDRIP': (str, False),
        'EC2SecurityGroupId': (str, False),
        'EC2SecurityGroupName': (str, False),
        'EC2SecurityGroupOwnerId': (str, False),
    }


class DBSecurityGroup(AWSObject):
    type = "AWS::RDS::DBSecurityGroup"

    props = {
        'EC2VpcId': (str, False),
        'DBSecurityGroupIngress': (list, True),
        'GroupDescription': (str, True),
    }


class DBSecurityGroupIngress(AWSObject):
    type = "AWS::RDS::DBSecurityGroupIngress"

    props = {
        'CIDRIP': (str, False),
        'DBSecurityGroupName': (str, True),
        'EC2SecurityGroupId': (str, True),
        'EC2SecurityGroupName': (str, True),
        'EC2SecurityGroupOwnerId': (str, True),
    }
